Subject: Re: tbench wrt. loopback TSO

From: Evgeniy Polyakov <[email-masked]>
Date: Sun, 26 Oct 2008 15:34:42 +0300

Hi.

On Wed, Oct 15, 2008 at 05:14:08PM -0700, David Miller ([email-masked]) wrote:
> 
> I got curious about this aspect of the investigation so I wanted
> to see it first-hand :-)
> 
> To be honest, this reported effect of disabling TSO in the loopback
> driver surprised me because:
> 
> 1) If the benchmark is doing small writes, TSO should have zero
>    effect.  The TSO logic won't kick in.

But GSO will try to create a huge packet and that overhead will not be
overweighted?

That's what I got with the current tree for 8 threads on a 4-way 32-bit
Xeons (2 physical CPUs) and 8gb of ram:
gso/tso off: 361.367
tso/gso on:  354.635

Disabled/enabled via ethtools: -k tso off/on gso off/on

> 2) If larger than MTU writes are being done, TSO should help,
>    and this is supported by other benchmarks :-)

Yes, that's where it is useful.

-- 
	Evgeniy Polyakov